VERSION 5.00
Begin VB.Form fMain 
   AutoRedraw      =   -1  'True
   Caption         =   "Form1"
   ClientHeight    =   8040
   ClientLeft      =   120
   ClientTop       =   420
   ClientWidth     =   11835
   LinkTopic       =   "Form1"
   ScaleHeight     =   536
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   789
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdStart 
      Caption         =   "START"
      Height          =   615
      Left            =   8760
      TabIndex        =   0
      Top             =   360
      Width           =   2415
   End
End
Attribute VB_Name = "fMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit


Private ProcessPath$, WithEvents M1 As cIPCMaster, WithEvents M2 As cIPCMaster
Attribute M1.VB_VarUserMemId = 1073938432
Attribute M2.VB_VarUserMemId = 1073938432

Private Const AreaW As Long = 2000
Private Const AreaH As Long = 1500


Private Sub Form_Load()

    ProcessPath = App.Path & "\" & App.EXEName & ".exe"    'define the WorkerProcess-Path

    If M1 Is Nothing Then Set M1 = CreateWorkerProcess((AreaW + 1) * (AreaH + 1) * 4 * 2 + 1024)
    If M2 Is Nothing Then Set M2 = CreateWorkerProcess((AreaW + 1) * (AreaH + 1) * 4 * 2 + 1024)

End Sub

Private Function CreateWorkerProcess(MemSizeToReserve) As cIPCMaster
    Set CreateWorkerProcess = New cIPCMaster
    If CreateWorkerProcess.InitAndBindWorkerTo(Me, MemSizeToReserve, ProcessPath) = 0 Then
        MsgBox "To be able to start a Worker, this Project needs to be compiled first"
    End If
End Function



Private Sub cmdStart_Click()
    Dim W   As Long
    Dim H   As Long
    Dim INP() As Single

    Dim X   As Long
    Dim Y   As Long
    Dim p   As tWorkArea

    W = AreaW
    H = AreaH

    ReDim INP(W, H)
    For X = 0 To W
        For Y = 0 To H
            INP(X, Y) = (Cos(X * 0.04) + Sin(Y * 0.04) + 2) * 0.25
        Next
    Next

    Me.Caption = "START Processing"
    StartStripeJob M1, INP, 0&
    StartStripeJob M2, INP, 1&


End Sub



Private Sub StartStripeJob(M As cIPCMaster, sngINP() As Single, Ntr As Long)
    Dim p   As tWorkArea

    p.W = UBound(sngINP, 1)
    p.H = UBound(sngINP, 2)

    Select Case Ntr
        Case 0
            p.StartY = 0
            p.EndY = p.H \ 2
        Case 1
            p.StartY = p.H \ 2 + 1
            p.EndY = p.H
    End Select

    M.UserDataWrite VarPtr(p), LenB(p)
    M.UserDataWrite VarPtr(sngINP(0, 0)), (p.W + 1) * (p.H + 1) * 4, LenB(p)

    M.JobState = jobPrepared

End Sub

Private Sub Form_Unload(Cancel As Integer)
    If Not (M1 Is Nothing) Then M1.CloseWorkerGracefully 1     'graceful close with a timeout of 1 second
    If Not (M2 Is Nothing) Then M2.CloseWorkerGracefully 1     'graceful close with a timeout of 1 second
End Sub

Private Sub M1_JobStateChanged(ByVal JobState As eJobState)
    If (M1.JobState = jobFinished) And (M2.JobState = jobFinished) Then DrawOUT
End Sub


Private Sub M2_JobStateChanged(ByVal JobState As eJobState)
    If (M1.JobState = jobFinished) And (M2.JobState = jobFinished) Then DrawOUT
End Sub

Private Sub DrawOUT()
' Raw output visualizer
    Dim W   As Long
    Dim H   As Long
    Dim X   As Long
    Dim Y   As Long
    Dim OUT1() As Single
    Dim OUT2() As Single
    Dim p   As tWorkArea
    Dim Area As Long

    Me.Caption = "START DRAW"

    M1.UserDataRead VarPtr(p), LenB(p)
    W = p.W
    H = p.H

    Area = (W + 1) * (H + 1) * 4

    ReDim OUT1(W, H)
    ReDim OUT2(W, H)

    M1.UserDataRead VarPtr(OUT1(0, 0)), Area, LenB(p) + Area
    M2.UserDataRead VarPtr(OUT2(0, 0)), Area, LenB(p) + Area
    For X = 0 To W
        For Y = 0 To H \ 2
            Me.PSet (X, Y), RGB(OUT1(X, Y) * 255, 0, 0)
        Next
    Next
    For X = 0 To W
        For Y = H \ 2 + 1 To H
            Me.PSet (X, Y), RGB(OUT2(X, Y) * 255, 0, 0)
        Next
    Next
    Me.Caption = "END DRAW"

End Sub
